
#    Note:  This is loaded into the namespace  ALIGN

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define ALIGN variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 4} {incr i} {variable Opt$i 0}
    for {set i 0} {$i <= 8} {incr i} {
    	variable Frame$i 0
    	variable Change$i 0
    }

    variable Cal 
    set Cal(Control) 0x800 
    set Cal(Status) 0x803
    set Cal(BitAlign) 0x802
    set Cal(WordAlign) 0x804


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
       for {set i 0} {$i <= 4} {incr i} {variable Opt$i; InsertLog "$i = [set Opt$i]"}
   }

   proc do_redisplay {} {

     for {set i 0} {$i <= 4} {incr i} {
        if {$i == 1} {continue}
        variable Opt$i
        set Opt$i [ReadAIDARegister [expr 0x800 + $i]]
     }
     foreach adc { 0 1 2 3 4 5 6 7 } {
     	     variable Frame$adc
     	     variable Change$adc
     	     set Frame$adc [ReadAIDARegister [expr 0xB10 +  ( $i << 1 )]]
     	     set Change$adc [ReadAIDARegister [expr 0xB11 +  ( $i << 1 )]]
     }
   }

   proc do_Set {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x800 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc Calibrate {} {
      variable allmodules
      variable Cal

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          InsertLog "Calibrating ADCs for FEE64 = $::AIDA::FEE64"

          for {set adc 0} {$adc <= 7} {incr adc} {
        
              WriteAD9252Register $adc 0x0d 0x48 ; # set for calibrate pattern
              WriteAD9252Register $adc 0xff 1   ;# device update
	      set val [ReadAD9252Register $adc 0xd ]
	      if { $val == 0x48 } {
		InsertLog "Pattern selected for ADC $adc ok"
	      } else {
		InsertLog "Pattern select failed for ADC $adc. Got $val not 0x48"
	      }
          }

  	  after 25 ;# try and see if a slow here helps
	  WriteAIDARegister $Cal(Control) 0
	  set val [ReadAIDARegister $Cal(Status)]
	  InsertLog " Status #1 : $val "
	  WriteAIDARegister $Cal(Control) 8
	  set val [ReadAIDARegister $Cal(Status)]
	  InsertLog " Status #2 : $val "
	  WriteAIDARegister $Cal(Control) 9
	  after 25 ; # here too
	  set val [ReadAIDARegister $Cal(BitAlign)]
	  InsertLog " Bit Align result : $val "
	  set val [ReadAIDARegister $Cal(WordAlign)]
	  InsertLog " Word Align result : $val "
          for {set i 0} {$i < 5} {incr i} {
	      set val [ReadAIDARegister $Cal(Status)]
              if {$val == 0xf7} {break}
              after 25    ;#  wait a bit more
          }
	  if {$val == 0xf7} {
              InsertLog "ADCs Calibrated. " 
	  } else {
	      InsertLog "Warning : Status is : $val not 0xF7 "
	      InsertLog " ADCs NOT Calibrated. Check they are set for Calibrate pattern"
	  }

          for {set adc 0} {$adc <= 7} {incr adc} {
             WriteAD9252Register $adc 0x0d 0 ; # set for data output
             WriteAD9252Register $adc 0xff 1   ;# device update
          }

	  InsertLog "ADCs Set for data transmission. " 
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc do_Calibrate {} {             ;# for remote execution from AIDA Control window
      variable allmodules
       variable JS

      set BAK $allmodules

puts "performing ADC calibrate"

       set JS ""

       set allmodules 1
       Calibrate

puts "ADC calibrate done"

      set allmodules $BAK

       return "$JS"
  }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT     {do_Set [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




