

#-0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1.0 -1.1 -1.2 -1.3 -1.4 
# variable Started 0

if {![info exists Started]} {variable Started 0}


if {$Started != 0} {

     variable JS ""
     variable LogFlag
     variable Showing

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    

}

if {$Started == 0} {           ;#  first time load code and define local variables

#
    set Started 1
    variable Showing 0 
    variable DBList { Empty }
    variable HistList { Empty }

	variable Peak_Tale {}

	variable Filter 0
	variable C_Upper 65535
	variable C_Lower 0
	variable FWHM_Boundary 16
	variable peak_list {}
	variable Peak_line {} ;# set of peaks for the linearity check

	variable Report_Level 0
	variable Error_level 1.0
	variable ASIC_chan "ASIC 0 : Channel 0"

	variable VoltList { 2.2 2.1 2.0 1.9 1.8 1.7 1.6 1.5 1.4 1.3 1.2 1.1 1.0 0.9 0.8 } 

    variable Fwhm_Limit 18.0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
	variable spectrum_filename ""
	variable specBase  "/MIDAS/SpecData/AIDA"
	variable specDir ""
	variable timestamp ""
	variable HistDir ""
	variable Histarget ""

    variable ShowLogFlag 0

    variable JS ""

    variable peakfindoptions
      set peakfindoptions(low-chan) 0
      set peakfindoptions(high-chan) 8191
      set peakfindoptions(fwhm)     20
      set peakfindoptions(accept)   10

proc show_variables {} {
	variable spectrum_filename
	variable timestamp
	variable specDir 
	variable peak_list
	variable VoltList

		InsertLog "Variables = $specDir\nFilename = $spectrum_filename\nTimestamp = $timestamp"
		InsertLog "$peak_list"
		InsertLog "VoltList = $VoltList"
}


proc do_HistDir {} {

	variable HistDir
	variable specDir
	variable specBase
	variable timestamp
	variable HistList {}
	variable Histarget

	set Acqserver [set ::DataAcquisition::ACQSERVER]

	set HistDir [ file join $specDir $timestamp]
	set rc [catch {exec ls $HistDir } m]
	if { $rc == 0 } {
		set HistList $m
	} else {
		InsertLog "Directory read for $specDir Failed!"
		set HistList {}
		set Histarget "" ;# indicates failure
	}

}

	proc do_SpecDir {} {

	variable specDir
	variable specBase
	variable timestamp
	variable DBList {}

	set Acqserver [set ::DataAcquisition::ACQSERVER]

	set specDir [ file join $specBase $Acqserver]
	set rc [catch {exec ls $specDir } m]
	if { $rc == 0 } {
		set DBList $m
	} else {
		InsertLog "Directory read for $specDir Failed!"
		set DBList {}
		set timestamp "" ;# indicates failure
	}

}

    proc do_peakhunt {} {
	variable peakfindoptions
	variable spectrum_filename
	variable specDir
	variable timestamp
        variable Fwhm_Limit
	variable results {}
	variable Peak_Tale
	variable Filter 
	variable C_Upper 
	variable C_Lower
	variable FWHM_Boundary
	variable peak_list


      set peakfindoptions(high-chan) 65535
      set peakfindoptions(fwhm) 20

	for { set i 0 } { $i < 64 } { incr i } { ;# set the counters to 0
		lappend peak_list 0
	}


	set peak_count 0
	set Peak_Tale {}
	for { set i 1 } { $i <= 4 } { incr i } {
		for { set j 0 } { $j < 16 } { incr j } { 
			set spectrum_filename [ file join $specDir $timestamp "$i.$j.L.msf" ]
			set execute "exec peakfind \
			   -spectrum $spectrum_filename \
			   -limit $peakfindoptions(low-chan) $peakfindoptions(high-chan) \
			   -fwhm $peakfindoptions(fwhm) \
			   -accept $peakfindoptions(accept)"

			set rc [catch {eval $execute} m]
#			InsertLog "$m"
			set k 0
			foreach item [split $m \n] {
			   incr k
			   if {$k < 3} {continue}
			   set peak_number [ lindex $item 0 ]
			   set center [first [split [ lindex $item 1 ] "("]]

			   set peak_count [ expr $peak_count + 1 ]
			   set idx [ expr ($i -1 ) * 16 + $j ]
			   set a [ expr [ lindex $peak_list $idx ] + 1 ]
			   set peak_list  [ lreplace $peak_list $idx $idx $a ] ;# increment the count of peaks
			   set fwhm [ scan [ last $item ] %f ]
			   if { $Filter == 0 } {
				   lappend Peak_Tale "ASIC $i Channel $j : Peak $peak_number has center = $center and fwhm = $fwhm\n"
			   } else { ;# filter the results
				if { $center > $C_Upper || $center < $C_Lower || $fwhm > $FWHM_Boundary } {
					lappend Peak_Tale "ASIC $i Channel $j : Peak $peak_number has center = $center and fwhm = $fwhm\n"
				}
			   }
			 
	 		}
			if { $k == 2 } {
				lappend Peak_Tale "No Peak in ASIC $i channel $j \n"
			}
		}
	}
	InsertLog "Total number of Peaks found is $peak_count"
	set first 0

	for { set i 0 } { $i < 64 } { incr i } { ;# scan through and look for multiple peaks
		set a  [ lindex $peak_list $i ]  
		if { $a == 1 || $a == 0  } { continue }
		if { $first == 0  } { lappend Peak_Tale "The following channel(s) have more than one Peak" }
		lappend Peak_Tale ", $i"
		set first 1		
	}


}

proc do_linfit_all {} {
	variable peakfindoptions
	variable spectrum_filename
	variable specDir
	variable timestamp
	variable Peak_Tale
	variable Peak_line ;# set of peaks for the linearity check
	variable Report_Level
	variable ASIC_chan

      set peakfindoptions(high-chan) 65535
      set peakfindoptions(fwhm) 20
      set peakfindoptions(accept) 110

	set peak_count 0
	set Peak_Tale {}

	for { set i 1 } { $i <= 4 } { incr i } {
		for { set j 0 } { $j < 16 } { incr j } { 
			set ASIC_chan "ASIC $i : Channel $j "
			set spectrum_filename [ file join $specDir $timestamp "$i.$j.L.msf" ]
			set execute "exec /disc/fcc/C-files/Peak_hunt/Peak_Hunt.o $spectrum_filename"
			set rc [catch {eval $execute} m]
# split the report and seek out the lines where linearity is greater than ???
			if { $Report_Level == 0 } {
				lappend Peak_Tale "$m"
			} else {
				set T_log [ split $m \n ]
				set last_entry [ split [ lindex $T_log [ expr [ llength $T_log ] - 1 ] ] " " ]
				set err [ scan [lindex $last_entry 2 ] "%f" ]
				if { $err > 0.1 } {
					lappend Peak_Tale "ASIC $i Channel $j Linearity average error= $err\n"
				}
				foreach item $T_log {
					set values [ split $item ":" ]
					if { [ llength $values ] == 5 } {
						set fwhm [ scan [ lindex $values 2 ] "%d" ]
						if { $fwhm > 20 } { lappend Peak_Tale "ASIC $i , Channel $j FWHM too big : $item\n" }
					}
				}
				
			}
		}
	}
	lappend Peak_Tale "\n All spectra tested for Time $timestamp\n"

}
    proc do_peak1hunt {} {
	variable peakfindoptions
	variable spectrum_filename
	variable HistDir
	variable Histarget
        variable Fwhm_Limit
	variable results {}
	variable Peak_Tale
	variable Filter 
	variable C_Upper 
	variable C_Lower
	variable FWHM_Boundary
	variable peak_list
	variable Peak_line ;# set of peaks for the linearity check
	variable Report_Level
	variable ASIC_chan


	set peak_count 0
	set Peak_Tale {}
	set Peak_line {}
	set ASIC_chan $Histarget
	set spectrum_filename [ file join $HistDir $Histarget ]
	set execute "exec /disc/fcc/C-files/Peak_hunt/Peak_Hunt.o $spectrum_filename"
	set rc [catch {eval $execute} m]

	lappend Peak_Tale "$m" 
}

proc do_lin_report { vl } { 
	variable Report_Level

	if { $vl < 0 || $vl > 1 } {
		InsertLog "Report Levels are 0 => report everything ; 1 => Report only linearity errors"
		set Report_Level 0
	} else {
		set Report_Level $vl
	}
}
proc do_Upper { vl } {

	variable Filter 
	variable C_Upper 
	variable C_Lower 

	if { $vl > 65535 || $vl < 0  } {
		set vl 65535
	}
	set C_Upper $vl
}
proc do_Lower { vl } {

	variable Filter 
	variable C_Upper 
	variable C_Lower 

	if { $vl > 65535 || $vl < 0  } {
		set vl 0
	}
	set C_Lower $vl
}
proc do_Fwhm { vl } {

	variable Filter 
	variable C_Upper 
	variable C_Lower
	variable FWHM_Boundary

	if { $vl > 100 || $vl < 0  } {
		set vl 0
	}
	set FWHM_Boundary $vl
}

proc do_DcScan {} {
	global env
	variable VoltList
	set execute "exec echo \"OPALL 1\" | nc \
	   -v\
	   193.62.115.136 9221"
	puts stderr "Requesting Output all on PSU"
	set rc [catch {eval $execute} m]
	if { $rc != 0 } {
		InsertLog "QL355TP Command returned rc = $rc | m = $m"
		return -1
	}

	foreach vref { 0.8 2.2 } {
		set execute "exec echo \"V2 $vref\" | nc \
		   -v\
		   193.62.115.136 9221"
		puts stderr "Requesting Voltage reference setting $vref"
		set rc [catch {eval $execute} m]
		if { $rc != 0 } {
			InsertLog "QL355TP Command returned rc = $rc | m = $m"
			return -1
		}
		puts stderr "DAQ GO requested"
		do_DAQ_Remote_Action "Go"

		puts stderr "DAQ ASIC readout GO requested"
		do_DAQ_Remote_Action "RDOGo"

		foreach item $VoltList { 
			set filename [ file join $env(MIDASBASE) TclHttpd Html AIDA Quality "GPIB.txt" ]
			set fileId [open $filename "w"]
			puts  $fileId "++ver"
			puts  $fileId "SET VOLT $item"

			close $fileId
			set execute "exec nc \
			   -v\
			   193.62.115.58 1234 \
			   < $filename"
			puts stderr "Requesting $item"
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				InsertLog "Command returned rc = $rc | m = $m"
				return -1
			}
			after 10000 ;# should be ten seconds 
		}

		puts stderr "DAQ STOP requested"
		do_DAQ_Remote_Action "Stop"

	}
	InsertLog "Scan complete"
	set execute "exec echo \"OPALL 0\" | nc \
	   -v\
	   193.62.115.136 9221"
	puts stderr "Requesting Output all off PSU"
	set rc [catch {eval $execute} m]
	if { $rc != 0 } {
		InsertLog "QL355TP Command returned rc = $rc | m = $m"
		return -1
	}

}
	proc do_DAQ_getSTATE {} {

		set Query_url "http://193.62.115.242:8015/DataAcquisitionControl/DataAcquisitionControl.tml?Query=do_getSTATE"
		set execute "exec curl -silent \"$Query_url\""
		set rc [catch {eval $execute} m]
		if { $rc != 0 } {
			InsertLog "Command returned rc = $rc | m = $m"
			return -1
		}
		set result [ split $m "\n"]
		set state [ lindex $result 10 ]
		set status [ split $state ";" ]
		set AcqState [lindex [ split [lindex $status 0 ] "=" ] 1 ] 
		set AcqText [lindex [ split [lindex $status 1 ] "=" ] 1 ]
		set StatusList  {}
		lappend StatusList $AcqState $AcqText
#		InsertLog " Status => $StatusList"
		return $StatusList

}
	proc do_DAQ_Remote_Action { vl } {

	set Stop_url "http://193.62.115.242:8015/DataAcquisitionControl/DataAcquisitionControl.tml?Action=do_STOP"
	set Go_url "http://193.62.115.242:8015/DataAcquisitionControl/DataAcquisitionControl.tml?Action=do_GO"
	set RDOGo_url "http://193.62.115.242:8015/DataAcquisitionControl/DataAcquisitionControl.tml?Action=do_RDOGo"

	
	switch -glob $vl {
		Stop {
			set execute "exec curl -silent \"$Stop_url\""
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				InsertLog "Command returned rc = $rc | m = $m"
				return -1
			}
			set flag 10
			set limit 10
			while { $flag != 0 && $limit != 0 } {
				set state [ do_DAQ_getSTATE ]
				set flag [ lindex $state 0 ]
				set limit [ expr $limit - 1 ]
			}
			puts stderr "Stop limit = $limit"
	 	}

		Go { 	
			set execute "exec curl -silent \"$Go_url\""
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				InsertLog "Command returned rc = $rc | m = $m"
				return -1
			}
			set flag 10
			set limit 10
			while { $flag != 1 && $limit != 0 } {
				set state [ do_DAQ_getSTATE ]
				set flag [ lindex $state 0 ]
				set limit [ expr $limit - 1 ]
			}
			puts stderr "Go limit = $limit"
	 	}

		RDOGo { 
			set execute "exec curl -silent \"$RDOGo_url\""
			set rc [catch {eval $execute} m]
			if { $rc != 0 } {
				InsertLog "Command returned rc = $rc | m = $m"
				return -1
			}
			set flag 10
			set limit 10
			while { $flag != 1 && $limit != 0 } {
				set state [ do_DAQ_getSTATE ]
				set flag [ lindex $state 0 ]
				set limit [ expr $limit - 1 ]
			}
			puts stderr "RDOGo limit = $limit"
	 	}


		default { InsertLog "Unknown Remote request selection $vl"}
	}

}
proc StepDelay {} {
# step through the ASIC readout delay settings
# only viable when run in the actual FEE64
}
    proc do_click {} {
	variable cgidata
	variable Started
	variable LogFlag
	variable ShowLogFlag
	variable JS
	variable DirName
	variable SpecDim
	variable timestamp
	variable Filter
	variable Histarget

	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [lindex $cgidata 1]
		set vl [second [lindex $cgidata 1]]
		
		
		switch -glob [lindex $w 0] {
		    
		    RESET    {set Started 0; return}
		    CLEAR    {EmptyLog}
		    ELOG     {PrintLog}
		    RELOAD   {variable Reloading; set Reloading 1}
		    VARIABLES {show_variables}
		    SERVER   {set ::DataAcquisition::ACQSERVER $vl}
		    DIRUPDT { do_SpecDir }
		    HSTLIST { do_HistDir }
		    PKFIND   {do_peakhunt }
		    PK1FIND   {do_peak1hunt }
		    LINFIT   {do_linfit_all }
		    LINREP   { do_lin_report $vl }

		    FILTER   { if { $Filter == 0 } then { set Filter 1 } else { set Filter 0 } }
		    UPPER    { do_Upper $vl }
		    LOWER    { do_Lower $vl }
		    FWHM     { do_Fwhm $vl }
		    DCSCAN   { do_DcScan }
		    DAQSTATE   { do_DAQ_getSTATE }

		    DBCHOOSE {set timestamp $vl }
		    HISTCHOOSE {set Histarget $vl }

                   EXPERT   {$vl}

		    HIDE     {set ShowLogFlag 0}
		    SHOW     {set ShowLogFlag 1}
		    LOGON    {set LogFlag 1}
		    LOGOFF   {set LogFlag 0}
		    
		    HELP     {
			variable HelpTopic
			set HelpTopic $vl
			do_help
		    }
		    undefined {}
		    default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata" }
		}
	    }
	}
    }
    set html ""
    do_SpecDir
}   ;# end of if {$Started == 0}



