
#    Note:  This is loaded into the namespace  TS

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 14} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }

   proc do_redisplay {} {

     WriteAIDARegister 0x404 0   ;# write to copy timestamp 
     foreach i {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14} {
        variable Opt$i
        set Opt$i [ReadAIDARegister [expr 0x400 + $i]]
     }
   }

   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x400 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc ShowTS {} {

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {

            set ::AIDA::FEE64 $fee64
 
            WriteAIDARegister 0x404 0           ;# write to copy timestamp 
            set LSW [ReadAIDARegister 0x404]   ;# read timestamp low 32 bits
            set MSW [ReadAIDARegister 0x405]   ;# read timestamp high 32 bits

            InsertLog "$::AIDA::FEE64: Timestamp = $MSW  $LSW"
      }

      set ::AIDA::FEE64 $BAK
  }

   proc ExtCLK {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x000 + 5] 0x20    ;#  reset  DCM
          WriteAIDARegister [expr 0x000 + 5] 0x1b    ;#  select clock from HDMI 
      }

      set ::AIDA::FEE64 $BAK   ;#  restore

      CLKstate
   }

   proc IntCLK {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x000 + 5] 0x20    ;#  reset  DCM
          WriteAIDARegister [expr 0x000 + 5] 0x7    ;#  select internal clock
      }

      set ::AIDA::FEE64 $BAK   ;#  restore

      CLKstate
   }

   proc CLKstate {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      set failed 0

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          set status [ReadAIDARegister  [expr 0x000 + 1] ]        ;#  status
          if {[expr $status] != 7} {incr failed; InsertLog "Clock not locked for $::AIDA::FEE64. status = $status"}
      }

      if {$failed == 0} {InsertLog "All module clocks locked"}

      set ::AIDA::FEE64 $BAK   ;#  restore

  }



   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




